#%%
import matplotlib.pyplot as plt
import numpy as np

Del = np.array([5, 15, 30, 60, 90, 120, 180, 240, 300])
Cost = np.array([40, 180, 490, 1490 ,2850, 4490, 8580, 13730 ,19880])

Cost = Cost * 1/3 * 1.2 * ((0.12 * 0.8) + 1)

CostDif = (Cost[1:] - Cost[:-1]) / (Del[1:] - Del[:-1])
print(CostDif)

# determine intersects
J = [1,3,5]
Intersect = [0]
for i in range(len(J)-1):
    j = J[i]
    jp = J[i+1]
    Intersect.append((Del[j]*CostDif[j] - Del[jp]*CostDif[jp] + Cost[jp] - Cost[j])/ (CostDif[j] - CostDif[jp]))
Intersect.append(Del[-1])
print(Intersect)
plt.figure(figsize= (4.5,3))
plt.plot(Del , Cost ,marker =  'o',color =  'dodgerblue',label = 'Actual Cost')

for i in range(len(J)):
    j = J[i]
    D2 = np.array(Intersect[i:i+2])
    plt.plot(Del , (Del - Del[j])*CostDif[j] + Cost[j],'--',color = 'navy')

plt.plot(Del[0],Cost[0],'--',color = 'navy',label = 'Linear Cost lower bounds')

plt.xlabel('Delay [minutes]')
plt.ylabel('Delay cost [€]')
plt.ylim(0,max(Cost)*1.05)
plt.legend()
plt.tight_layout()
plt.savefig('Output/DelayCostLinApprox.pdf')
plt.show()
# %%
