#%% -*- coding: utf-8 -*-
"""
Created on Thu Oct 13 14:34:52 2022

@author: simon
"""
import numpy   as np
import pandas  as pd
import os 
import datetime as dt
import matplotlib.pyplot as plt
import matplotlib
import matplotlib.dates as mdates

from time import sleep
from collections import defaultdict
import  E_AC_Infra_Object_Classes as  OBJ


def Date_and_time_conv(date,time):
    
    s_time = date + ' ' + time
    return dt.datetime.strptime(s_time, "%d %b %Y %I:%M %p")
    

    
def Read_airports(airports_file):
    airports = pd.read_csv(airports_file, sep = ':')
    
    ap = {}
    for i in range(len(airports)):
        if type(airports.iloc[i,1]) != float: 
            ap[airports.iloc[i,1]] = OBJ.Airport(name = airports.iloc[i,0],
                                             ICAO = airports.iloc[i,0],
                                             IATA = airports.iloc[i,1],
                                             lat  = airports.iloc[i,14],
                                             long = airports.iloc[i,15])
    return ap

def Read_flight_Schedule(file_folder, airports):
    flights = {}
    used_airports = []
    global filename 
    for filename in os.listdir(file_folder):
        ac = filename[:6]
        print('')
        print(ac)
        flights[ac] = []
        schedule = pd.read_csv(file_folder +'/'+ filename, sep = '\t')
        print(' schedule read')
        
        # strip whitespaces from schedule
        for i in range(0,len(schedule),2):
            #schedule.iloc[i,4] = schedule.iloc[i,4].strip()
            #print(schedule.iloc[i,1])
            schedule.iloc[i,2] = schedule.iloc[i,2].strip()
            if type(schedule.iloc[i,3]) == str:
                schedule.iloc[i,3] = schedule.iloc[i,3].strip()
            schedule.iloc[i+1,1] = schedule.iloc[i+1,1].strip()
            #schedule.iloc[i,]
        
        i = -2
        per = 0
        while abs(i) < len(schedule):
            
            if schedule.iloc[i+1,1][:6] in ['Landed', 'Divert']:
                if int(abs(i)/len(schedule)*100) > per:
                    per = int(abs(i)/len(schedule)*100)
                    print(per, end = ' ')
                #print(schedule.iloc[i,:])   
                # add flight to schedule
                fln = schedule.iloc[i,4]
                ori = schedule.iloc[i,2][-4:-1]
                if schedule.iloc[i+1,1][:6] == 'Divert':
                    dst = schedule.iloc[i+1,1][-3:]
                else:
                    dst = schedule.iloc[i,3][-4:-1]
                
                if len(schedule.iloc[i,7]) > 2:
                    t_dep = dt.datetime.strptime(schedule.iloc[i,1] + ' ' + schedule.iloc[i,7], 
                                                 "%d %b %Y %I:%M %p")
                    if len(schedule.iloc[i,5]) > 2:
                        t_arr = t_dep + dt.timedelta(hours = int(schedule.iloc[i,5][:-3]),
                                                     minutes = int(schedule.iloc[i,5][-2:]))
                    else:
                        #print(schedule.iloc[i,5])
                        std = dt.datetime.strptime(schedule.iloc[i,1] + ' ' + schedule.iloc[i,6], 
                                                 "%d %b %Y %I:%M %p")
                        sta = dt.datetime.strptime(schedule.iloc[i,1] + ' ' + schedule.iloc[i,8], 
                                                 "%d %b %Y %I:%M %p")
                        dif = sta - std
                        t_arr = t_dep + dif
                    
                    
                    used_airports += [airports[ori],airports[dst]]
                    
                    flights[ac].append((t_dep,fln,airports[ori],airports[dst],t_arr))
            i += -2
        flights[ac].sort()
    
    ap = {a.IATA : a for a in set(used_airports)}
    return flights, ap
                
def Conv_Flights_To_Batteries(flights, hubs, airports, range_fl, C , Pch):
    batteries = {ac: [] for ac in flights}
    
    tot_capt_fl = 0
    for ac in flights:
        print(ac, end = ', ')
        
        cur_indx     = 0
        while cur_indx < len(flights[ac]):
            #sleep(1)
        #    print(cur_indx)
            j = cur_indx
            while j < len(flights[ac]):
                if flights[ac][j][2] in hubs:
                    k = j 
                    while k < len(flights[ac]):
                        if flights[ac][k][3] in hubs:
                            break
                        k = k + 1
                else:
                    j = j + 1
                    continue
                break
            #print(ac,j,k)
            if j == len(flights[ac]):
                curr_indx = j
            elif k < len(flights[ac]):
           #     print(ac, j,k, end = ' , ' )
            
                # determine if the path between the hubs is feasible
                length = 0
                feasible = 1
                for indx in range(j,k+1):
                    ap1 = flights[ac][indx][2]
                    ap2 = flights[ac][indx][3]
    
                    length += 35 + OBJ.Great_circle_distance(ap1.long , ap1.lat , ap2.long, ap2.lat)
                    if length > range_fl:
                        feasible = 0
                    
                    if indx != k:
                        # add the possibility of charging at spoke airports
                        t_arr = flights[ac][indx][4]
                        t_dep = flights[ac][indx + 1 ][0]
                        t_charge = t_dep - t_arr - dt.timedelta(minutes= 10)

                        length += - max(0 , t_charge.total_seconds())/3600 * range_fl / (C/Pch)
                        length = max(length , 0)

            #    print('len: ',int(length), end = ', ')
                if feasible == 1:
                   # print(' TRUE, ')
                    # add trip to battery schedule
                    batteries[ac].append((j,k, flights[ac][j], flights[ac][k], length, ac, k-j + 1))
                    
                    tot_capt_fl += k-j + 1
                    
     #           else:
                  #  print(' FALSE, ')
                    
                
                cur_indx = k  + 1
            else:
                cur_indx = k + 1
        j = 0
            
    print('\n\nYOW: We have captured ' , tot_capt_fl, ' of ', sum(len(flights[ac]) for ac in flights), ' flights\n')
    
    return batteries

def Sort_batteries_per_day_and_airport(batteries, hubs):
    
    sorted_bats = {h:defaultdict(list) for h in hubs}
    
    for ac in batteries:
        for b in batteries[ac]:
            d_dep = dt.datetime(b[2][0].year, b[2][0].month, b[2][0].day)
            d_arr = dt.datetime(b[3][4].year, b[3][4].month, b[3][4].day)
            
            sorted_bats[b[2][2]][d_dep].append(b)
            if not(b[2][2] == b[3][3] and d_dep == d_arr):
                sorted_bats[b[3][3]][d_arr].append(b)
            
    return sorted_bats

def Create_Day_Schedule_Instance(batteries, hub , date, 
                                 n_c , n_s ,  
                                 c_delay, range_max, bat_cap, pc_max, 
                                 c_e_off , c_e_peak):
    
    start_of_day = dt.datetime(year = date.year, month = date.month, day = date.day, hour = 4)
    end_of_day  = start_of_day + dt.timedelta(days = 1) # AM, start of the day of operations
    
    c_elec = [(dt.datetime(date.year, date.month, date.day, 4) ,
               dt.datetime(date.year, date.month, date.day, 7) , c_e_off),
              (dt.datetime(date.year, date.month, date.day, 7) ,
               dt.datetime(date.year, date.month, date.day, 20) , c_e_peak),
              (dt.datetime(date.year, date.month, date.day, 20) ,
               dt.datetime(date.year, date.month, date.day, 7) +
               dt.timedelta(days = 1) , c_e_off),
              (dt.datetime(date.year, date.month, date.day, 7)  + dt.timedelta(days = 1) ,
               dt.datetime(date.year, date.month, date.day, 20) + dt.timedelta(days = 1) , c_e_off),
              ]
    
    
    departures = []
    arrivals = []
    
    # select the jobs for the given airport 
    for b in batteries[hub][date]:
        ac = b[5]
        if b[2][2] == hub and b[2][0] >= start_of_day and b[2][0] <= end_of_day:
            # we have a departure of this battery on this day
            dep  = OBJ.Departure(b[2][0], ac)
            departures.append(dep)
        if b[3][3] == hub and b[3][4] < end_of_day and b[3][4] >= start_of_day:
            # we have an arrival of this battery on this day
            t_c = b[4] / range_max * bat_cap / pc_max * 3600 # charging time (hours)
            bat = OBJ.Battery(b[3][4] , t_c, ac)
            arrivals.append(bat)
    
    if date + dt.timedelta(days = 1) in batteries[hub]:
        for b in batteries[hub][date + dt.timedelta(days = 1)]:
            ac = b[5]
            if b[2][2] == hub and b[2][0]  < end_of_day and b[2][0] >= date + dt.timedelta(days = 1):
                # we have a departure of this battery on this day
                dep  = OBJ.Departure(b[2][0], ac)
                departures.append(dep)
            if b[3][3] == hub and b[3][4] < end_of_day and b[3][4] >= start_of_day:
                # we have an arrival of this battery on this day
                t_c = b[4] / range_max * bat_cap / pc_max * 3600# charging time (seconds)
                bat = OBJ.Battery(b[3][4] , t_c, ac)
                arrivals.append(bat)
            
    # copy in order to account for aircraft size differences
    # print(arrivals)
    # print(departures)
    
    # calculate the number of overnight batteries
    first_ac_spot = defaultdict(list)
    for dep in departures:
        ac = dep.ac
        if ac in first_ac_spot:
            if first_ac_spot[ac][0] > dep.t_d:
                first_ac_spot[ac] = (dep.t_d, 'dep')
        else:
            first_ac_spot[ac] = (dep.t_d, 'dep')
    
    for arr in arrivals:
        ac = arr.ac
        if ac in first_ac_spot: 
            if first_ac_spot[ac][0] > arr.t_a:
                first_ac_spot[ac] = (arr.t_a, 'arr')
        else:
            first_ac_spot[ac] = (arr.t_a, 'arr')
    
    n_night = 0
    for ac in first_ac_spot:
        if first_ac_spot[ac][1] == 'dep':
            n_night += 1
    # print('n_night ', n_night)
    
    INST = OBJ.E_AC_Charge_Schedule_Instance(start_of_day , arrivals, departures,  
                                             n_s, n_c, n_night, c_elec, c_delay)
     
    return INST

def Day_Selector(sb, hub , N_dates):
    dates           = list(sb[hub].keys())
    
    size_dates      = [(len(sb[hub][day]) , day) for day in dates]
    size_dates.sort()
    
    # day sampler 
    st              = int(len(dates)/N_dates)
    sampled_dates   = [size_dates[-i][1] for i in np.arange(len(size_dates), step = st)]
    sampled_dates   = sampled_dates[1:] + [size_dates[-1][1]]
    
    # peak day selection
    peak_date       = [size_dates[-1][1]]
    
    # median day selection
    median_date     = [ sampled_dates[ int( len(sampled_dates) /2 ) ] ]
    
    return sampled_dates , peak_date, median_date

#%% Plotting stufs

def PLot_Flights(flights , batteries):
    HIST = defaultdict(int)
    visit = defaultdict(int)

    for ac in batteries:
        for b in batteries[ac]:
            j = b[0] ; k = b[1]
            for i in range(j,k+1):
                HIST[(flights[ac][i][2], flights[ac][i][3])] += 1
                visit[flights[ac][i][2]] += 1
    
    max_fl = max(list(HIST.values()))
    max_vs = max(list(visit.values()))                
                
    fig, ax = plt.subplots(figsize = (6,7))
    img = plt.imread("input_data/Map_of_norway.png")

    ax.imshow(img, extent = [4.1 , 31.6 , 57.6 , 71.5 ], zorder = -4)
    
    for (a,b) in HIST:
        if HIST[(a,b)] <= 0.25*max_fl:
            st = ':'
        elif HIST[(a,b)] <= 0.50 * max_fl:
            st = '-.'
        elif HIST[(a,b)] <= 0.75 *max_fl:
            st = '--'
        else:
            st = '-'
            
        st = '-'
        plt.plot([a.long, b.long] , [a.lat, b.lat] , color = 'dodgerblue',linewidth = 2*HIST[(a,b)]/max_fl, linestyle = st ,zorder = -3)
        
    ax.scatter([a.long for a in visit],[a.lat for a in visit] , s = 200*np.sqrt(np.array([visit[a]/max_vs for a in visit])), color = 'red')
    ax.set_aspect(2.5)
    for a in visit:
        if visit[a]>0:
            plt.text(a.long,a.lat, a.IATA,horizontalalignment = 'right',fontsize = 8)


    "SEt axis limits"
    ax.set_ylim([57.6 , 71.5])
    ax.set_xlim([4.1 , 31.6 ]) # Wideroe
    #ax.set_extent([-75,-65, 40, 47], crs=ccrs.PlateCarree()) # CapeAir
    #ax.set_extent([-130,-117, 46, 52], crs=ccrs.PlateCarree()) # Morningstar
    
    # plt.plot([0,0],[1,1],linestyle = ':', color = 'red',label = '< ' + str(int(0.25*max_fl/52)) +' flights/week')
    # plt.plot([0,0],[1,1],linestyle = '-.',color = 'red', label = '< ' + str(int(0.5*max_fl/52)) +' flights/week')
    # plt.plot([0,0],[1,1],linestyle = '--',color = 'red', label = '< ' + str(int(0.75*max_fl/52)) +' flights/week')
    # plt.plot([0,0],[1,1],linestyle = '-',color = 'red', label = '< ' + str(int(1.00*max_fl/52)) +' flights/week')
    
    plt.scatter([0],[0], color = 'red', s = 200*np.sqrt(0.25), label = str(int(0.25*max_vs/52)) + ' flights/week' )
    plt.scatter([0],[0], color = 'red', s = 200*np.sqrt(0.5), label = str(int(0.5*max_vs/52)) + ' flights/week' )
    plt.scatter([0],[0], color = 'red', s = 200*np.sqrt(0.75), label = str(int(0.75*max_vs/52)) + ' flights/week' )
    plt.scatter([0],[0], color = 'red', s = 200*np.sqrt(1), label = str(int(1*max_vs/52)) + ' flights/week' )
    
    plt.title('Network Wideroe with hubs')
    plt.legend(ncol = 1, loc = 'lower right')
    plt.show()
    
    
    # Plot top routes

def PlotMostPopAps(flights):
    n_fl = defaultdict(int)
    
    for ac in flights:
        for f in flights[ac]:
            n_fl[f[2]] += 1
            n_fl[f[3]] += 1
    
    
    tot_travelled = [(n_fl[a], a) for a in n_fl]
    tot_travelled.sort()
    
    most_pop_ap = [tot_travelled[-i][1] for i in range(1,20)]
    
    x = np.arange(len(most_pop_ap))
    
    fig,ax = plt.subplots(nrows = 1, figsize = (6,3))
    ax.bar(x, [n_fl[a] for a in most_pop_ap], color = 'dodgerblue')
    ax.set_xticks(x)
    ax.set_xticklabels([a.IATA for a in most_pop_ap],  rotation = 45)
    plt.ylabel('Annual flights by Wideroe')

def PlotInOutHist(sb):
    """plot the difference between incoming and outgoing flights per day, in order to assess reasonability of time frame"""
    delta = []
    for h in sb:
        for d in sb[h]:
            dif = 0
            for f in sb[h][d]:
                if f[2][2] == h:
                    dif += -1
                if f[3][3] == h:
                    dif += 1
            delta.append(dif)
    plt.figure()
    plt.hist(delta)
    
def PlotCostImage(ax, Nc, Ns, COST):
    cost = np.mean(COST,axis = 2)

    #fig, ax = plt.subplots(figsize = (6,6))
    im = ax.imshow(cost, aspect="auto")
    ax.set_xticks(list(range(len(Ns))))
    ax.set_yticks(list(range(len(Nc))))
    ax.set_xticklabels(Ns)
    ax.set_yticklabels(Nc)
    ax.set_xlabel('Spare batteries')
    ax.set_ylabel('Chargers')
    
    for i in range(len(Nc)):
        for j in range(len(Ns)):
            text = ax.text(j, i, int(cost[i, j]),
                           ha="center", va="center", color="w")
         
            
def PlotChargingSchedule(INST, T_c, T_c_max, title):
    cvals  = [0,0.01 ,50, 99 ,100]
    colors = ['white',"red","orange","green","darkgreen"]
    
    norm=plt.Normalize(min(cvals),max(cvals))
    tuples = list(zip(map(norm,cvals), colors))
    colmap = matplotlib.colors.LinearSegmentedColormap.from_list("", tuples)

    # for each battery, determine the pickup time
    nbats = INST.n_n + INST.n_s + len(INST.bats)
    nspare = INST.n_n + INST.n_s
    soc = np.zeros((nbats, len(INST.Intervals)))
    batrow = np.arange(nbats)
    
    # List of battery arrival times
    t_arr = [INST.start_of_day] * nspare + [b.t_a for b in INST.bats]
    t_deps = [d.t_d for d in INST.deps]
    t_rdy  = [(INST.start_of_day, i) for i in range(nspare)] 
    
    soc[:nbats, :] = T_c_max
    for i in range(len(INST.bats)):
        r = False
        b = INST.bats[i]
        soc[i + nspare, :] = T_c_max - b.t_c
        for t in range(len(INST.Intervals)):
            if INST.Intervals[t] in b.I:
                soc[i + nspare, t] = soc[i + nspare , t - 1] + T_c[(b , INST.Intervals[t])]
                if r == False and soc[i + nspare ,t] >= 0.995 * T_c_max:
                    r = True
                    t_rdy.append((INST.Intervals[t].t_e, i + nspare))
        for t in range(len(INST.Intervals)):
            if not(INST.Intervals[t] in b.I):
                soc[i + nspare ,t] = 0
    
    soc = soc / T_c_max * 100
    
    t_rdy.sort()
    t_deps.sort()
    t_deps += [INST.end_of_day] * (len(t_rdy) - len(t_deps))

    for i in range(len(t_rdy)):
        td = max(t_rdy[i][0] , t_deps[i])
        ib = t_rdy[i][1]
        for t in range(len(INST.Intervals)):
            if INST.Intervals[t].t_s >= td:
                soc[ib,t] = 0
    
    # final step, stack the batteries 
    moved = []
    for i in range(len(t_rdy)):
        # arrival time is first nonzero
        t_a = np.where(soc[i,:] > 0)[0][0]
        
        # available time is last nonzero of previous rows
        t_av = []
        for j in range(i):
            if len(np.where(soc[j,:] > 0)[0]) > 0:
                t_av.append((np.where(soc[j,:] > 0)[0][-1]+1 , j))
            
        # pick the row with smallest available time smaller than arrival time
        moved = 0
        if len(t_av) > 0:
            t_av.sort()
            if t_av[0][0] <= t_a:
                moved = 1
                soc[t_av[0][1] , t_av[0][0]:] = soc[i , t_av[0][0]:]
                soc[i, :] = 0*soc[i,:]
                batrow[i] = t_av[0][1]
        if moved == 0:
            if i > 0:
                j = 0
                x = True
                while x == True:
                    if sum(soc[j,:])  == 0:
                        soc[j,:] = soc[i,:]
                        soc[i,:] = 0 * soc[i,:]
                        batrow[i] = j
                        x = False
                    else:
                        j += 1
                        if j == i:
                            x = False
    
    imax = np.where(np.sum(soc,axis = 1) > 0)[0][-1] +1
    soc = soc[:imax,:]
    
    
    fig , ax = plt.subplots(figsize = (8,4))
    
    im = ax.imshow(soc, cmap = colmap, aspect = 'auto', vmin = 0 , vmax = 100)
    
    for i in range(len(t_rdy)):
        td = max(t_rdy[i][0] , t_deps[i])
        ib = t_rdy[i][1]
        #print(i, td, t_deps[i], ib , batrow[ib])
        t1 = (td         - INST.start_of_day).seconds/900 + (td         - INST.start_of_day).days*96
        t2 = (t_deps[i]  - INST.start_of_day).seconds/900 + (t_deps[i]  - INST.start_of_day).days*96
        t2 = min(t2 + 1  , t1 )
        print(t1 , t2)
        ax.plot([t1, t2] , [batrow[ib], batrow[ib]] , '->', color = 'black',linewidth = 2)
    
    ax.set_yticks(np.arange(-.5, imax, 1), minor=True)

    # Gridlines based on minor ticks
    ax.grid(which='minor', axis = 'y', color='w', linestyle='-', linewidth=2)
    
    # Remove minor ticks
    ax.tick_params(which='minor', bottom=False, left=False)
    
    T = np.arange(0,97, 16)
    ax.set_xticks(T)
    ax.set_xticklabels([INST.Intervals[t].t_s.strftime('%H:%M') for t in T])
    ax.set_xlabel('Time')
    ax.set_ylabel('Battery index')
    cb = fig.colorbar(im)
    cb.set_label('Battery state-of-charge [%]')
    ax.set_xlim((0,100))
    plt.tight_layout()
    ax.set_title(title)
    #ax.xaxis.set_major_formatter(mdates.DateFormatter('%H:%M'))
    
            
