# -*- coding: utf-8 -*-
"""
Created on Mon Oct 17 14:38:00 2022

@author: sjmvanoosterom
"""
# create new figure, axes instances.
import matplotlib.pyplot as plt
import cartopy.crs as ccrs
from E_AC_Infra_Background_Functions import Read_airports
from E_AC_Infra_Object_Classes import Great_circle_distance
import numpy as np
import pandas as pd

#%%

airports = Read_airports('input_data/GlobalAirportDatabase.txt')

flights = pd.read_excel('input_data/FR24_Wideroe.xlsx')

ap = list(flights.iloc[:,0])

fl = {a:{} for a in ap}
max_fl = 0
for i in range( len(flights)):
    for j in range(1, len(flights)):
        if not(np.isnan(flights.iloc[i,j])):
            fl[ap[i]][ap[j]] = flights.iloc[i,j]
            max_fl = max(max_fl ,flights.iloc[i,j] )


ax = plt.axes(projection=ccrs.Mercator())

ax.set_global()
ax.stock_img()

ax.coastlines()
ax.plot([airports[a].long for a in ap],[airports[a].lat for a in ap] , 'o', transform=ccrs.PlateCarree())
for a in ap:
    plt.annotate(a, (airports[a].long,airports[a].lat), transform=ccrs.PlateCarree())



for a in fl:
    for b in fl[a]:
        if fl[a][b] <= 0.25*max_fl:
            st = ':'
        elif fl[a][b] <= 0.50 * max_fl:
            st = '-.'
        elif fl[a][b] <= 0.75 * max_fl:
            st = '--'
        else:
            st = '-'
        plt.plot([airports[a].long, airports[b].long] , [airports[a].lat, airports[b].lat] , color = 'red', linestyle = st, transform=ccrs.Geodetic() )
#plt.plot([-0.08, 132], [51.53, 43.17], color='red',  transform=ccrs.Geodetic())
#plt.plot([-0.08, 132], [51.53, 43.17], color='blue', transform=ccrs.PlateCarree())

plt.show()

#%%
airports = Read_airports('input_data/GlobalAirportDatabase.txt')
f= pd.read_csv('input_data/flight_paths_wideroe.txt',',',names=list(range(103)))

# region selection

regio = 'E' # C:canada , E europe north , K USA



ap2 = {}
for a in airports.values():
    if a.ICAO[0] == regio:
        ap2[a.IATA] = a

tot_visit = {a:0 for a in ap2.values()}
tot_fl   = {a:{b:0 for b in ap2.values()} for a in ap2.values()}
tot_max_fl = 0
for ac in range(len(f)):
    path = list(f.iloc[ac,1:])
    name = str(f.iloc[ac,0])
    if type(path[0]) == str:
        # plt.figure()
        # ax = plt.axes(projection=ccrs.Mercator())
        # ax.set_global()
        # ax.stock_img()
        # ax.coastlines()
        #ax.plot([airports[a].long for a in ap],[airports[a].lat for a in ap] , 'o', transform=ccrs.PlateCarree())
        
        fl = {a:{b:0 for b in ap2.values()} for a in ap2.values()}
        visit = {a:0 for a in ap2.values()}
        max_fl = 0
        for i in range(len(path)-1):
            ori = path[i]
            dst = path[i+1]
            if type(dst) == str:
                if dst != 'nan' and ori != 'nan':
                    #print(ori)
                    ori = ap2[ori]
                    dst = ap2[dst]
                    #print(ori)
                    if ori.ICAO =='KTNX':
                        print('alert at ',ac, i)
                    fl[ori][dst] += 1
                    visit[ori] += 1
                    tot_fl[ori][dst] += 1
                    tot_visit[ori] += 1
                    tot_max_fl = max(tot_max_fl, tot_fl[ori][dst])
                    max_fl = max(max_fl ,fl[ori][dst] )
                
        # ax.scatter([a.long for a in visit],[a.lat for a in visit] , s = 30*np.sqrt(np.array([visit[a] for a in visit])), transform=ccrs.PlateCarree())
        #ax.set_xlim([3, 34])
        #ax.set_ylim([55,71])
        # ax.set_extent([3, 34, 55, 72], crs=ccrs.PlateCarree())
        # for a in fl:
        #     for b in fl[a]:
        #         if fl[a][b] >0:
        #             if fl[a][b] <= 0.25*max_fl:
        #                 st = ':'
        #             elif fl[a][b] <= 0.50 * max_fl:
        #                 st = '-.'
        #             elif fl[a][b] <= 0.75 * max_fl:
        #                 st = '--'
        #             else:
        #                 st = '-'
                    # plt.plot([a.long, b.long] , [a.lat, b.lat] , color = 'red', linestyle = st, transform=ccrs.Geodetic() )
    # plt.title(name)
    
# Remove not used airports from fl

#%%

plt.figure()
ax = plt.axes(projection=ccrs.Mercator())

ax.set_global()
ax.stock_img()

ax.coastlines()
ax.scatter([a.long for a in tot_visit],[a.lat for a in tot_visit] , s = 30*np.sqrt(np.array([tot_visit[a] for a in visit])), transform=ccrs.PlateCarree())
for a in visit:
    if tot_visit[a]>0:
        plt.text(a.long,a.lat, a.IATA,horizontalalignment = 'right', transform=ccrs.Geodetic())
# for a in ap:
#     plt.annotate(a, (airports[a].long,airports[a].lat), transform=ccrs.PlateCarree())

plt.title('total flights')

for a in tot_fl:
    for b in tot_fl[a]:
        if tot_fl[a][b] >0:
            if tot_fl[a][b] <= 0.25*tot_max_fl:
                st = ':'
            elif tot_fl[a][b] <= 0.50 * tot_max_fl:
                st = '-.'
            elif tot_fl[a][b] <= 0.75 *tot_max_fl:
                st = '--'
            else:
                st = '-'
            print(a,b,tot_fl[a][b])
            plt.plot([a.long, b.long] , [a.lat, b.lat] , color = 'red',linewidth = 2, linestyle = st, transform=ccrs.PlateCarree() )
#plt.plot([-0.08, 132], [51.53, 43.17], color='red',  transform=ccrs.Geodetic())
#plt.plot([-0.08, 132], [51.53, 43.17], color='blue', transform=ccrs.PlateCarree())

"SEt axis limits"
ax.set_extent([3, 34, 55, 72], crs=ccrs.PlateCarree()) # Wideroe
#ax.set_extent([-75,-65, 40, 47], crs=ccrs.PlateCarree()) # CapeAir
#ax.set_extent([-130,-117, 46, 52], crs=ccrs.PlateCarree()) # Morningstar

plt.plot([0,0],[1,1],linestyle = ':', color = 'red',label = '< ' + str(int(0.25*tot_max_fl)) +' flights/week')
plt.plot([0,0],[1,1],linestyle = '-.',color = 'red', label = '< ' + str(int(0.5*tot_max_fl)) +' flights/week')
plt.plot([0,0],[1,1],linestyle = '--',color = 'red', label = '< ' + str(int(0.75*tot_max_fl)) +' flights/week')
plt.plot([0,0],[1,1],linestyle = '-',color = 'red', label = '< ' + str(int(1.00*tot_max_fl)) +' flights/week')

plt.title('Network Wideroe')
plt.legend()
plt.show()


#%% Analyze the flight lengths
lengths = []
for a in tot_fl:
    for b in tot_fl[a]:
        if b != a:
            lengths += [Great_circle_distance(a.long, a.lat, b.long, b.lat)]*tot_fl[a][b]
    
plt.figure()
plt.hist(lengths, bins = 20)
plt.xlabel('flight distance [km]')
plt.title('Flight leg distance histogram')

#%% Analyze the largest hubs in the grid

capture_single_hub = {}
IATAairports = {}

for a in airports:
    IATAairports[airports[a].IATA] = airports[a]
IATAairports['nan'] = np.nan
    
for hub in tot_visit:
    if tot_visit[hub] >0:
        hubs = [hub]
        tot_capt_fl = 0
        tot_dist_fl = 0
        tot_dist = 0
        
        for ac in range(len(f)):
            path = list(f.iloc[ac,1:])
            range_left = 750*0.85
            curr_indx = 0
            hubss = []
            while curr_indx < len(path):
                # determine tthe next set of hubs
                nanor = 0
                j = curr_indx 
                #k = curr_indx
                while j < len(path):
                    if IATAairports[str(path[j])] in hubs:
                        k = j + 1
                        while k < len(path):
                            if IATAairports[str(path[k])] in hubs:
                                break
                            k = k + 1
                    else:
                        j = j + 1
                        continue
                    break
           #     hubss.append(k)
                if j == len(path):
                   curr_indx = j
                elif j < k and k < len(path):
                    print(ac, j,k, end = ' , ' )
                
                    # determine if the path between the hubs is feasible
                    length = 0
                    for indx in range(j,k):
                        ap1 = IATAairports[path[indx]]
                        ap2 = IATAairports[path[indx+1]]
                        length += 35 + Great_circle_distance(ap1.long , ap1.lat , ap2.long, ap2.lat)
                        
                    if length <= range_left:
                        print(' TRUE, ')
                        tot_capt_fl += k-j
                        tot_dist_fl = length - 35*(k-j)
                    else:
                        print(' FALSE, ')
                        
                    
                    curr_indx = k 
                else:
                    curr_indx = k
            j = 0
            
            while j < len(path):
                if not(type(path[j])) == str:
                    break
                else:
                    if j > 0:
                        a1 = IATAairports[path[j]]
                        a2 = IATAairports[path[j-1]]
                        tot_dist += Great_circle_distance(a1.long , a1.lat , a2.long, a2.lat)
                j += 1
        print(' ' )
        capture_single_hub[hub] = tot_capt_fl
        #capture_single_hub[hub] = tot_dist_fl

            


tot_travelled = [(capture_single_hub[a], a) for a in tot_visit if tot_visit[a] >0]
tot_travelled.sort()

most_pop_ap = [tot_travelled[-i][1] for i in range(1,20)]

x = np.arange(len(most_pop_ap))

fig,ax = plt.subplots(nrows = 1)
ax.bar(x, [capture_single_hub[a] for a in most_pop_ap])
ax.set_xticks(x,[a.IATA for a in most_pop_ap])
plt.title('Most used hubs, Wideroe')

#%% determine the number of flights captured by the top airports
capture = []
total_nr_fl  = []
hub_indx = []
#most_pop_ap = most_pop_ap[:4] + [most_pop_ap[12] , most_pop_ap[15]]
    
for i in range(1,len(most_pop_ap) +1):
    hubs = most_pop_ap[:i]
    tot_capt_fl = 0
    not_capt_fl = 0
    for ac in range(len(f)):
        path = list(f.iloc[ac,1:])
        range_left = 750*0.85
        curr_indx = 0
        hubss = []
        while curr_indx < len(path):
            # determine tthe next set of hubs
            nanor = 0
            j = curr_indx 
            while j < len(path):
                if IATAairports[str(path[j])] in hubs:
                    k = j + 1
                    while k < len(path):
                        if IATAairports[str(path[k])] in hubs:
                            break
                        k = k + 1
                else:
                    j = j + 1
                    continue
                break
            hubss.append(k)
                        

            print(ac, j,k, end = ' , ' )
            if j < k and k < len(path):
                # determine if the path between the hubs is feasible
                length = 0
                for indx in range(j,k):
                    ap1 = IATAairports[path[indx]]
                    ap2 = IATAairports[path[indx+1]]
                    length += 35 + Great_circle_distance(ap1.long , ap1.lat , ap2.long, ap2.lat)
                    
                if length <= range_left:
                    print(' TRUE, ')
                    tot_capt_fl += k-j
                else:
                    print(' FALSE, ')
                    
                
                curr_indx = k 
            else:
                curr_indx = k
        j = 0
        while j < len(path):
            if not(type(path[j])) == str:
                break
            j += 1
        not_capt_fl += j
    print(' ' )
    capture.append( tot_capt_fl)
    total_nr_fl.append(  not_capt_fl)
    hub_indx.append(hubss)
        

x = np.arange(len(most_pop_ap))

fig,ax = plt.subplots(nrows = 1)
ax.bar(x, capture)
ax.plot([0,max(x)],[total_nr_fl[0],total_nr_fl[0]], '--r')
ax.set_xticks(x,[a.IATA for a in most_pop_ap])
plt.title('Network capture with charging stations')